Name:           quvi
Version:        0.2.17 
Release:        1
Summary:        Command line tool for parsing video download links
Group:          Applications/Internet
License:        LGPLv2+
URL:            http://code.google.com/p/quvi/
Source0:        http://%{name}.googlecode.com/files/%{name}-%{version}.tar.bz2
Source1:        http://%{name}.googlecode.com/files/%{name}-%{version}.tar.bz2.md5
Source2:        http://%{name}.googlecode.com/files/%{name}-%{version}.tar.bz2.sig
Patch0:         %{name}-%{version}-aix.patch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

BuildRequires:  curl-devel >= 7.19.7-1
BuildRequires:  lua-devel >= 5.1.4-2
BuildRequires:  pcre-devel >= 7.9-2
BuildRequires:  readline-devel >= 5.2-3

Requires:  curl >= 7.19.7-1
Requires:  lua >= 5.1.4-2
Requires:  pcre >= 7.9-2
Requires:  readline >= 5.2-3

%define _libdir64 %{_prefix}/lib64

%description
quvi is a command line tool for parsing video download links.
It supports Youtube and other similar video websites.
libquvi is a library for parsing video download links with C API.
It is written in C and intended to be a cross-platform library.

The library is available as 32-bit and 64-bit.


%package devel
Summary: Files needed for building applications with libquvi
Group: Development/Libraries
Requires: %{name} = %{version}-%{release}
Requires: pkg-config

%description devel
Files needed for building applications with libquvi.

If you are compiling a 32-bit program, no special compiler options are
needed.

If you are compiling a 64-bit program, you have to compile and link your
application with "cc -q64" or "gcc -maix64".


%prep
%setup -q
%patch0
mkdir ../32bit
mv * ../32bit
mv ../32bit .
mkdir 64bit
cd 32bit && tar cf - . | (cd ../64bit ; tar xpf -)


%build
export CONFIG_SHELL=/usr/bin/ksh
export CONFIG_ENV_ARGS=/usr/bin/ksh

export CC="cc -qcpluscmt"

cd 64bit
# first build the 64-bit version
export OBJECT_MODE=64
export LDFLAGS="-L/opt/freeware/lib64 -L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib64:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --libdir=%{_libdir64} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-quvi \
    --enable-nsfw
make %{?_smp_mflags}

cd ../32bit
# now build the 32-bit version
export OBJECT_MODE=32
export LDFLAGS="-L/opt/freeware/lib -Wl,-blibpath:/opt/freeware/lib:/usr/lib:/lib -Wl,-bmaxdata:0x80000000"
./configure \
    --prefix=%{_prefix} \
    --mandir=%{_mandir} \
    --enable-shared --disable-static \
    --enable-quvi \
    --enable-nsfw
make %{?_smp_mflags}


%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
export OBJECT_MODE=64
gmake DESTDIR=${RPM_BUILD_ROOT} install

cd ../32bit
export OBJECT_MODE=32
gmake DESTDIR=${RPM_BUILD_ROOT} install

/usr/bin/strip -X32_64 ${RPM_BUILD_ROOT}%{_bindir}/* || :

(
  cd ${RPM_BUILD_ROOT}%{_libdir64}
  for f in *.a ; do
    /usr/bin/ar -X64 -x ${f}
  done

  cd ${RPM_BUILD_ROOT}%{_libdir}
  for f in *.a ; do
    /usr/bin/ar -X32 -x ${f}
  done
)

# add the 64-bit shared objects to the shared libraries containing already the
# 32-bit shared objects
/usr/bin/ar -X64 -q ${RPM_BUILD_ROOT}%{_libdir}/lib%{name}.a ${RPM_BUILD_ROOT}%{_libdir64}/lib%{name}.so*

(
  cd ${RPM_BUILD_ROOT}
  for dir in bin include lib lib64
  do
    mkdir -p usr/${dir}
    cd usr/${dir}
    ln -sf ../..%{_prefix}/${dir}/* .
    cd -
  done
)


%clean
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,system,-)
%doc 32bit/ChangeLog 32bit/COPYING 32bit/README 
%{_bindir}/*
%{_libdir}/*.a
%{_libdir}/*.so*
%{_libdir64}/*.so*
%{_mandir}/man1/*
%{_datadir}/%{name}/
/usr/bin/*
/usr/lib/*.a
/usr/lib/*.so*
/usr/lib64/*.so*


%files devel
%defattr(-,root,system,-)
%doc 32bit/examples/simple.c 32bit/doc/nd/
%{_includedir}/*
%{_libdir}/*.la
%{_libdir64}/*.la
%{_libdir}/pkgconfig/*.pc
%{_libdir64}/pkgconfig/*.pc
/usr/include/*
/usr/lib/*.la
/usr/lib64/*.la


%changelog
* Sat Jun 18 2011 Michael Perzl <michael@perzl.org> - 0.2.17-1
- updated to version 0.2.17

* Mon May 16 2011 Michael Perzl <michael@perzl.org> - 0.2.15-1
- updated to version 0.2.15

* Fri Mar 11 2011 Michael Perzl <michael@perzl.org> - 0.2.14-1
- first version for AIX V5.1 and higher
